<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>userDetail</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
  </head>

  <body>
    <div class="container w-50">
      <div class="text-center m-3">
        <h3 style="color: rgb(63, 63, 203);">THÔNG TIN CHI TIẾT NGƯỜI DÙNG</h3>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="input-user-id"
          >Nhập Id của user <span class="text-danger">(*)</span></label
        >
        <div class="col-sm-5">
          <input
            id="input-user-id"
            placeholder="Nhập id user ..."
            class="form-control"
          />
        </div>
        <div class="col-sm-3">
          <button class="btn btn-primary" onclick="onBtnLayThongTinClick()">
            Lấy thông tin
          </button>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-12">
          Một số id user đúng để test:
          <span class="text-danger"
            >181211, 181214, 181215, 181219, 181226, 181231, 181232</span
          >
        </div>
      </div>

      <hr />

      <div class="row form-group mt-4">
        <label class="col-form-label col-sm-4" for="input-firstname"
          >First name <span class="text-danger">(*)</span></label
        >
        <div class="col-sm-8">
          <input
            id="input-firstname"
            placeholder="First name"
            class="form-control"
          />
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="input-lastname"
          >Last name <span class="text-danger">(*)</span></label
        >
        <div class="col-sm-8">
          <input
            id="input-lastname"
            placeholder="Last name"
            class="form-control"
          />
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="input-subject"
          >Subject <span class="text-danger">(*)</span></label
        >
        <div class="col-sm-8">
          <input
            type="text"
            id="input-subject"
            placeholder="Subject"
            class="form-control"
          />
        </div>
      </div>

      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="select-country"
          >Country</label
        >
        <div class="col-sm-8">
          <select id="select-country" class="form-control">
            <option value="VN">Việt Nam</option>
            <option value="AUS">Australia</option>
            <option value="USA">USA</option>
            <option value="CAN">Canada</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="select-customer-type"
          >Customer Type</label
        >
        <div class="col-sm-8">
          <select id="select-customer-type" class="form-control">
            <option value="Gold">Gold</option>
            <option value="Premium">Premium</option>
            <option value="Standard">Standard</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="select-register-status"
          >Register Status</label
        >
        <div class="col-sm-8">
          <select id="select-register-status" class="form-control">
            <option value="Accepted">Accepted</option>
            <option value="Denied">Denied</option>
            <option value="New">New</option>
          </select>
        </div>
      </div>

      <div
        style="
          width: 100%;
          display: flex;
          justify-content: end;
          margin-bottom: 30px;
        "
      >
        <button class="btn btn-primary" onclick="onBtnCapNhatUserClick()">
          Cập nhật User
        </button>
      </div>
    </div>
  </body>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_FINISH_AND_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi nút Lấy thông tin được click
    function onBtnLayThongTinClick() {
      "use strict";
      // Bước 0: Tạo đối tượng chứa dữ liệu thu thập
      var vObject = {
        userId: "",
      };
      // Bước 1: Thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: Xử lý Ajax
      if (vCheck == true) {
        // tạo ra đối tượng request và gửi đi
        var vXmlHttp = new XMLHttpRequest();
        processAjax(vXmlHttp, vObject.userId);
        // nhận về response và xử lý

        var vStatusCode = vXmlHttp.status;
        // nếu trạng thái trả về thành công!
        if (vStatusCode == gREQUEST_STATUS_FINISH_AND_OK) {
          // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
          console.log(vXmlHttp.responseText);
          var bUserIdResponse = JSON.parse(vXmlHttp.responseText);
          // Bước 4: Hiển thị kết quả
          displayData(bUserIdResponse);
        } else {
          // Bước 4: Hiển thị kết quả
          alert("Không tồn tại User với id đã nhập");
        }
      }
    }

    //hàm thực thi khi nút Cập nhật User được click
    function onBtnCapNhatUserClick() {
      "use strict";
      // Bước 0: Tạo đối tượng chứa dữ liệu thu thập
      var vObject = {
        userId: "",
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
        registerStatus: "",
      };
      // Bước 1: Thu thập dữ liệu
      getDataFromInputCapNhat(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateDataCapNhat(vObject);
      // Bước 3: Xử lý Ajax
      if (vCheck == true) {
        //B3: gọi api
        var vXmlHttp = new XMLHttpRequest();
        goiApi(vObject, vXmlHttp);

        vXmlHttp.onreadystatechange = function () {
          // Khi request đã xử lý xong và thành công!
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_FINISH_AND_OK
          ) {
            //B4: hiển thị thông tin
            alert("Cập nhật thành công");
            console.log(this.responseText);
          }
        };
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
      "use strict";
      // lấy giá trị nhập vào
      var vElementUserIdInput = document.getElementById("input-user-id");
      var vUserId = vElementUserIdInput.value;
      paramObject.userId = vUserId;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là true / false
    function validateData(paramObject) {
      "use strict";
      var vResult = true;

      var vUserId = paramObject.userId.trim();

      if (vUserId == "") {
        alert("Bạn chưa nhập user ID!");
        vResult = false;
      }

      if (isNaN(vUserId)) {
        alert("User ID phải là số!");
        vResult = false;
      }

      return vResult;
    }

    // Hàm xử lý ajax
    function processAjax(paramRequest, paramUserId) {
      "use strict";
      paramRequest.open(
        "GET",
        "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
        false
      );
      paramRequest.send();
    }

    // Hàm hiển thị dữ liệu
    // Input là dữ liệu cần hiển thị
    function displayData(paramData) {
      "use strict";
      var vFirstnameInputE = document.getElementById("input-firstname");
      var vLastnameInputE = document.getElementById("input-lastname");
      var vSubjectInputE = document.getElementById("input-subject");
      var vCountrySelectE = document.getElementById("select-country");
      var vCustomerTypeSelectE = document.getElementById(
        "select-customer-type"
      );
      var vRegisterStatusSelectE = document.getElementById(
        "select-register-status"
      );

      vFirstnameInputE.value = paramData.firstname;
      vLastnameInputE.value = paramData.lastname;
      vSubjectInputE.value = paramData.subject;
      vCountrySelectE.value = paramData.country;
      vCustomerTypeSelectE.value = paramData.customerType;
      vRegisterStatusSelectE.value = paramData.registerStatus;
    }

    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInputCapNhat(paramObject) {
      "use strict";
      // lấy giá trị nhập vào
      var vUserIdInputE = document.getElementById("input-user-id");
      var vFirstnameInputE = document.getElementById("input-firstname");
      var vLastnameInputE = document.getElementById("input-lastname");
      var vSubjectInputE = document.getElementById("input-subject");
      var vCountrySelectE = document.getElementById("select-country");
      var vCustomerTypeSelectE = document.getElementById(
        "select-customer-type"
      );
      var vRegisterStatusSelectE = document.getElementById(
        "select-register-status"
      );

      var vUserIdInput = vUserIdInputE.value.trim();
      var vFirstnameInput = vFirstnameInputE.value.trim();
      var vLastnameInput = vLastnameInputE.value.trim();
      var vSubjectInput = vSubjectInputE.value.trim();
      var vCountrySelect = vCountrySelectE.value;
      var vCustomerTypeSelect = vCustomerTypeSelectE.value;
      var vRegisterStatusSelect = vRegisterStatusSelectE.value;

      paramObject.userId = vUserIdInput;
      paramObject.firstname = vFirstnameInput;
      paramObject.lastname = vLastnameInput;
      paramObject.subject = vSubjectInput;
      paramObject.country = vCountrySelect;
      paramObject.customerType = vCustomerTypeSelect;
      paramObject.registerStatus = vRegisterStatusSelect;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là true / false
    function validateDataCapNhat(paramObject) {
      if (paramObject.userId == "") {
        alert("Bạn chưa nhập user ID!");
        return false;
      }

      if (paramObject.firstname == "") {
        alert("Bạn chưa nhập first name!");
        return false;
      }

      if (paramObject.lastname == "") {
        alert("Bạn chưa nhập last name!");
        return false;
      }

      if (paramObject.subject == "") {
        alert("Bạn chưa nhập subject!");
        return false;
      }

      return true;
    }

    //hàm gọi api
    function goiApi(paramUserObj, paramXmlHttp) {
      // chuyển object về chuỗi JSON
      var vUserJsonData = JSON.stringify(paramUserObj);

      // mở và gửi request đi
      paramXmlHttp.open("PUT", gBASE_URL + paramUserObj.userId, true);
      paramXmlHttp.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      paramXmlHttp.send(vUserJsonData);
    }
  </script>
</html>
